
// From the extremely thorough list here: http://positivewordsresearch.com/list-of-negative-words/
var badWords = ["abnormal", "abolish", "abominable", "abominably", "abominate", "abomination", "abort", "aborted", "aborts", "abrade", "abrasive", "abrupt", "abruptly", "abscond", "absence", "absent-minded", "absentee", "absurd", "absurdity", "absurdly", "absurdness", "abuse", "abused", "abuses", "abusive", "abysmal", "abysmally", "abyss", "accidental", "accost", "accursed", "accusation", "accusations", "accuse", "accuses", "accusing", "accusingly", "acerbate", "acerbic", "acerbically", "ache", "ached", "aches", "aching", "acrid", "acridly", "acridness", "acrimonious", "acrimoniously", "acrimony", "adamant", "adamantly", "addict", "addicted", "addicting", "addicts", "admonish", "admonisher", "admonishingly", "admonishment", "admonition", "adulterate", "adulterated", "adulteration", "adversarial", "adversary", "adverse", "adversity", "afflict", "affliction", "afflictive", "affront", "afraid", "aggravate", "aggravating", "aggravation", "aggression", "aggressive", "aggressiveness", "aggressor", "aggrieve", "aggrieved", "aghast", "agonies", "agonize", "agonizing", "agonizingly", "agony", "aground", "ail", "ailing", "ailment", "aimless", "alarm", "alarmed", "alarming", "alarmingly", "alienate", "alienated", "alienation", "allegation", "allegations", "allege", "allergic", "allergies", "allergy", "aloof", "altercation", "ambiguity", "ambiguous", "ambivalence", "ambivalent", "ambush", "amiss", "amputate", "anarchism", "anarchist", "anarchistic", "anarchy", "anemic", "anger", "angrily", "angriness", "angry", "anguish", "animosity", "annihilate", "annihilation", "annoy", "annoyance", "annoyances", "annoyed", "annoying", "annoyingly", "annoys", "anomalous", "anomaly", "antagonism", "antagonist", "antagonistic", "antagonize", "anti-", "anti-occupation", "anti-proliferation", "anti-social", "anti-us", "anti-white", "antipathy", "antiquated", "antithetical", "anxieties", "anxiety", "anxious", "anxiously", "anxiousness", "apathetic", "apathetically", "apathy", "apocalypse", "apocalyptic", "apologist", "apologists", "appall", "appalled", "appalling", "appallingly", "apprehension", "apprehensions", "apprehensive", "apprehensively", "arbitrary", "arcane", "archaic", "arduous", "arduously", "argumentative", "arrogance", "arrogant", "arrogantly", "ashamed", "asinine", "asininely", "askance", "asperse", "aspersion", "aspersions", "assail", "assassin", "assassinate", "assault", "astray", "asunder", "atrocious", "atrocities", "atrocity", "atrophy", "attack", "attacks", "audacious", "audaciously", "audaciousness", "audacity", "austere", "authoritarian", "autocrat", "autocratic", "avalanche", "avarice", "avaricious", "avariciously", "avenge", "averse", "aversion", "awful", "awfully", "awfulness", "awkward", "awkwardness", "ax", "babble", "back-logged", "back-wood", "back-woods", "backache", "backaches", "backbite", "backbiting", "backward", "backwardness", "backwoods", "bad", "badly", "baffle", "baffled", "bafflement", "baffling", "bait", "balk", "banal", "bane", "banish", "banishment", "bankrupt", "barbarian", "barbaric", "barbarically", "barbarity", "barbarous", "barbarously", "barren", "baseless", "bash", "bashed", "bashful", "bashing", "bastard", "bastards", "battered", "battering", "batty", "bearish", "beastly", "bedlam", "bedlamite", "befoul", "beg", "beggar", "beggarly", "begging", "beguile", "belabor", "belated", "beleaguer", "belie", "belittle", "belittled", "belittling", "bellicose", "belligerence", "belligerent", "belligerently", "bemoan", "bemoaning", "bemused", "bent", "berate", "bereave", "bereavement", "bereft", "berserk", "beseech", "beset", "besiege", "besmirch", "bestial", "betray", "betrayal", "betrayals", "betrayer", "betraying", "betrays", "bewail", "beware", "bewilder", "bewildered", "bewildering", "bewilderingly", "bewilderment", "bewitch", "bias", "biased", "biases", "bicker", "bickering", "bid-rigging", "bigotries", "bigotry", "bitch", "bitchy", "biting", "bitingly", "bitter", "bitterly", "bitterness", "bizarre", "blab", "blabber", "blackmail", "blah", "blame", "blameworthy", "bland", "blandish", "blaspheme", "blasphemous", "blasphemy", "blasted", "blatant", "blatantly", "blather", "bleak", "bleakly", "bleakness", "bleed", "bleeding", "bleeds", "blemish", "blind", "blinding", "blindingly", "blindside", "blister", "blistering", "bloated", "blockage", "blockhead", "bloodshed", "bloodthirsty", "bloody", "blotchy", "blow", "blunder", "blundering", "blunders", "blunt", "blur", "blurred", "blurring", "blurry", "blurs", "blurt", "boastful", "boggle", "bogus", "boil", "boiling", "boisterous", "bomb", "bombard", "bombardment", "bombastic", "bondage", "bonkers", "bore", "bored", "boredom", "bores", "boring", "botch", "bother", "bothered", "bothering", "bothers", "bothersome", "bowdlerize", "boycott", "braggart", "bragger", "brainless", "brainwash", "brash", "brashly", "brashness", "brat", "bravado", "brazen", "brazenly", "brazenness", "breach", "break", "break-up", "break-ups", "breakdown", "breaking", "breaks", "breakup", "breakups", "bribery", "brimstone", "bristle", "brittle", "broke", "broken", "broken-hearted", "brood", "browbeat", "bruise", "bruised", "bruises", "bruising", "brusque", "brutal", "brutalities", "brutality", "brutalize", "brutalizing", "brutally", "brute", "brutish", "buckle", "bug", "bugging", "buggy", "bugs", "bulkier", "bulkiness", "bulky", "bullshit", "bull—-", "bullies", "bullshit", "bully", "bullying", "bullyingly", "bum", "bump", "bumped", "bumping", "bumps", "bumpy", "bungle", "bungler", "bungling", "bunk", "burden", "burdensome", "burdensomely", "burn", "burned", "burning", "burns", "bust", "busts", "busybody", "butcher", "butchery", "buzzing", "byzantine", "cackle", "calamities", "calamitous", "calamitously", "calamity", "callous", "calumniate", "calumniation", "calumnies", "calumnious", "calumniously", "calumny", "cancer", "cancerous", "cannibal", "cannibalize", "capitulate", "capricious", "capriciously", "capriciousness", "capsize", "careless", "carelessness", "caricature", "carnage", "carp", "cartoonish", "cash-strapped", "castigate", "castrated", "casualty", "cataclysm", "cataclysmal", "cataclysmic", "cataclysmically", "catastrophe", "catastrophes", "catastrophic", "catastrophically", "caustic", "caustically", "cautionary", "cave", "censure", "chafe", "chaff", "chagrin", "challenging", "chaos", "chaotic", "chasten", "chastise", "chastisement", "chatter", "chatterbox", "cheapen", "cheat", "cheated", "cheater", "cheating", "cheats", "checkered", "cheerless", "cheesy", "chide", "childish", "chill", "chilly", "chintzy", "choke", "choleric", "choppy", "chore", "chronic", "chunky", "clamor", "clamorous", "clash", "clique", "clog", "clogged", "clogs", "clueless", "clumsy", "clunky", "coarse", "cocky", "coerce", "coercion", "coercive", "cold", "coldly", "collapse", "collude", "collusion", "combative", "combust", "comical", "commiserate", "commonplace", "commotion", "commotions", "complacent", "complain", "complained", "complaining", "complains", "complaint", "complaints", "complex", "complicated", "complication", "complicit", "compulsion", "compulsive", "concede", "conceded", "conceit", "conceited", "concern", "concerned", "concerns", "concession", "concessions", "condemn", "condemnable", "condemnation", "condemned", "condemns", "condescend", "condescending", "condescendingly", "condescension", "confess", "confession", "confessions", "confined", "conflict", "conflicted", "conflicting", "conflicts", "confound", "confounded", "confounding", "confront", "confrontation", "confrontational", "confuse", "confused", "confuses", "confusing", "confusion", "confusions", "congested", "congestion", "cons", "conservative", "conspicuous", "conspicuously", "conspiracies", "conspiracy", "conspirator", "conspiratorial", "conspire", "consternation", "contagious", "contaminate", "contaminated", "contaminates", "contaminating", "contamination", "contempt", "contemptible", "contemptuous", "contemptuously", "contend", "contention", "contentious", "contort", "contortions", "contradict", "contradiction", "contradictory", "contrariness", "contravene", "contrive", "contrived", "controversial", "controversy", "convoluted", "corrode", "corrosion", "corrosions", "corrosive", "corrupt", "corrupted", "corrupting", "corruption", "corrupts", "costlier", "costly", "counter-productive", "counterproductive", "covetous", "coward", "cowardly", "crabby", "crack", "cracked", "cracks", "craftily", "crafty", "cramp", "cramped", "cramping", "cranky", "crap", "crappy", "craps", "crash", "crashed", "crashes", "crashing", "crass", "craven", "cravenly", "craze", "crazily", "craziness", "crazy", "creak", "creaking", "creaks", "credulous", "creep", "creeping", "creeps", "creepy", "crept", "crime", "criminal", "cringe", "cringed", "cringes", "cripple", "crippled", "cripples", "crippling", "crisis", "critic", "critical", "criticism", "criticisms", "criticize", "criticized", "criticizing", "critics", "cronyism", "crook", "crooked", "crooks", "crowded", "crowdedness", "crude", "cruel", "crueler", "cruelest", "cruelly", "cruelness", "cruelties", "cruelty", "crumble", "crumbling", "crummy", "crumple", "crumpled", "crumples", "crush", "crushed", "crushing", "cry", "culpable", "culprit", "cumbersome", "cunt", "cunts", "curse", "cursed", "curses", "curt", "cuss", "cussed", "cutthroat", "cynical", "cynicism", "damage", "damaged", "damages", "damaging", "damn", "damnable", "damnably", "damnation", "damned", "damning", "damper", "danger", "dangerous", "dangerousness", "dark", "darken", "darkened", "darker", "darkness", "dastard", "dastardly", "daunt", "daunting", "dauntingly", "dawdle", "daze", "dazed", "dead", "deadbeat", "deadlock", "deadly", "deadweight", "deaf", "dearth", "death", "debacle", "debase", "debasement", "debaser", "debatable", "debauch", "debaucher", "debauchery", "debilitate", "debilitating", "debility", "debt", "debts", "decadence", "decadent", "decay", "decayed", "deceit", "deceitful", "deceitfully", "deceitfulness", "deceive", "deceiver", "deceivers", "deceiving", "deception", "deceptive", "deceptively", "declaim", "decline", "declines", "declining", "decrement", "decrepit", "decrepitude", "decry", "defamation", "defamations", "defamatory", "defame", "defect", "defective", "defects", "defensive", "defiance", "defiant", "defiantly", "deficiencies", "deficiency", "deficient", "defile", "defiler", "deform", "deformed", "defrauding", "defunct", "defy", "degenerate", "degenerately", "degeneration", "degradation", "degrade", "degrading", "degradingly", "dehumanization", "dehumanize", "deign", "deject", "dejected", "dejectedly", "dejection", "delay", "delayed", "delaying", "delays", "delinquency", "delinquent", "delirious", "delirium", "delude", "deluded", "deluge", "delusion", "delusional", "delusions", "demean", "demeaning", "demise", "demolish", "demolisher", "demon", "demonic", "demonize", "demonized", "demonizes", "demonizing", "demoralize", "demoralizing", "demoralizingly", "denial", "denied", "denies", "denigrate", "denounce", "dense", "dent", "dented", "dents", "denunciate", "denunciation", "denunciations", "deny", "denying", "deplete", "deplorable", "deplorably", "deplore", "deploring", "deploringly", "deprave", "depraved", "depravedly", "deprecate", "depress", "depressed", "depressing", "depressingly", "depression", "depressions", "deprive", "deprived", "deride", "derision", "derisive", "derisively", "derisiveness", "derogatory", "desecrate", "desert", "desertion", "desiccate", "desiccated", "desolate", "desolately", "desolation", "despair", "despairing", "despairingly", "desperate", "desperately", "desperation", "despicable", "despicably", "despise", "despised", "despoil", "despoiler", "despondence", "despondency", "despondent", "despondently", "despot", "despotic", "despotism", "destitute", "destitution", "destroy", "destroyer", "destruction", "destructive", "desultory", "deter", "deteriorate", "deteriorating", "deterioration", "deterrent", "detest", "detestable", "detestably", "detested", "detesting", "detests", "detract", "detracted", "detracting", "detraction", "detracts", "detriment", "detrimental", "devastate", "devastated", "devastates", "devastating", "devastatingly", "devastation", "deviate", "deviation", "devil", "devilish", "devilishly", "devilment", "devilry", "devious", "deviously", "deviousness", "devoid", "diabolic", "diabolical", "diabolically", "diametrically", "diatribe", "diatribes", "dick", "dictator", "dictatorial", "die", "die-hard", "died", "dies", "difficult", "difficulties", "difficulty", "diffidence", "dilapidated", "dilemma", "dilly-dally", "dim", "dimmer", "ding", "dings", "dinky", "dire", "direly", "direness", "dirt", "dirty", "disable", "disabled", "disaccord", "disadvantage", "disadvantaged", "disadvantageous", "disadvantages", "disaffect", "disaffected", "disaffirm", "disagree", "disagreeable", "disagreeably", "disagreed", "disagreeing", "disagreement", "disagrees", "disallow", "disappoint", "disappointed", "disappointing", "disappointingly", "disappointment", "disappointments", "disappoints", "disapprobation", "disapproval", "disapprove", "disapproving", "disarm", "disarray", "disaster", "disastrous", "disastrously", "disavow", "disavowal", "disbelief", "disbelieve", "disbeliever", "disclaim", "discombobulate", "discomfit", "discomfort", "discompose", "disconcert", "disconcerted", "disconcerting", "disconcertingly", "disconsolate", "disconsolately", "disconsolation", "discontent", "discontented", "discontentedly", "discontinued", "discontinuity", "discontinuous", "discord", "discordance", "discordant", "discountenance", "discourage", "discouragement", "discouraging", "discouragingly", "discourteous", "discourteously", "discredit", "discrepant", "discriminate", "discrimination", "discriminatory", "disdain", "disdained", "disdainful", "disdainfully", "disfavor", "disgrace", "disgraced", "disgraceful", "disgracefully", "disgruntle", "disgruntled", "disgust", "disgusted", "disgustedly", "disgustful", "disgustfully", "disgusting", "disgustingly", "dishearten", "disheartening", "dishearteningly", "dishonest", "dishonestly", "dishonesty", "dishonor", "dishonorable", "disillusion", "disillusioned", "disillusionment", "disillusions", "disinclination", "disinclined", "disingenuous", "disingenuously", "disintegrate", "disintegrated", "disintegrates", "disintegration", "disinterest", "disinterested", "dislike", "disliked", "dislikes", "disliking", "dislocated", "disloyal", "disloyalty", "dismal", "dismally", "dismalness", "dismay", "dismayed", "dismaying", "dismayingly", "dismissive", "dismissively", "disobedience", "disobedient", "disobey", "disorder", "disordered", "disorderly", "disorganized", "disorient", "disoriented", "disown", "disparage", "disparaging", "disparagingly", "dispensable", "dispirit", "dispirited", "dispiritedly", "dispiriting", "displace", "displaced", "displease", "displeased", "displeasing", "displeasure", "disproportionate", "disprove", "disputable", "dispute", "disputed", "disquiet", "disquieting", "disquietingly", "disquietude", "disregard", "disregardful", "disreputable", "disrepute", "disrespect", "disrespectable", "disrespectful", "disrespectfully", "disrespectfulness", "disrespecting", "disrupt", "disruption", "disruptive", "dissatisfaction", "dissatisfactory", "dissatisfied", "dissatisfies", "dissatisfy", "dissatisfying", "dissed", "dissemble", "dissembler", "dissension", "dissent", "dissenter", "dissention", "disservice", "disses", "dissidence", "dissident", "dissidents", "dissing", "dissocial", "dissolute", "dissolution", "dissonance", "dissonant", "dissonantly", "dissuade", "dissuasive", "distains", "distaste", "distasteful", "distastefully", "distort", "distorted", "distortion", "distorts", "distract", "distracting", "distraction", "distraught", "distraughtly", "distress", "distressed", "distressing", "distressingly", "distrust", "distrustful", "distrusting", "disturb", "disturbance", "disturbed", "disturbing", "disturbingly", "disunity", "disvalue", "divergent", "divisive", "divisively", "divisiveness", "dizzy", "doddering", "dogged", "doggedly", "dogmatic", "doldrums", "domineer", "domineering", "doom", "doomed", "doomsday", "dope", "doubt", "doubtful", "doubtfully", "doubts", "douchebag", "douchebags", "downbeat", "downcast", "downer", "downfall", "downfallen", "downgrade", "downhearted", "downheartedly", "downhill", "downside", "downsides", "downturn", "downturns", "drab", "draconian", "draconic", "drag", "dragged", "dragging", "dragoon", "drags", "drain", "drained", "draining", "drains", "drastic", "drastically", "drawback", "drawbacks", "dread", "dreadful", "dreadfully", "dreadfulness", "dreary", "dripped", "dripping", "drippy", "drips", "drones", "droop", "droops", "drop-out", "drop-outs", "dropout", "dropouts", "drought", "drowning", "drunk", "drunkard", "drunken", "dubious", "dubiously", "dubitable", "dud", "dull", "dullard", "dumb", "dumbfound", "dump", "dumped", "dumping", "dumps", "dunce", "dungeon", "dungeons", "dupe", "dust", "dusty", "dwindling", "dying", "earsplitting", "eccentric", "eccentricity", "effigy", "effrontery", "egocentric", "egomania", "egotism", "egotistical", "egotistically", "egregious", "egregiously", "election-rigger", "elimination", "emaciated", "emasculate", "embarrass", "embarrassing", "embarrassingly", "embarrassment", "embattled", "embroil", "embroiled", "embroilment", "emergency", "emphatic", "emphatically", "emptiness", "encroach", "encroachment", "endanger", "enemies", "enemy", "enervate", "enfeeble", "enflame", "enmity", "enrage", "enraged", "enraging", "enslave", "entangle", "entanglement", "entrap", "entrapment", "envious", "enviously", "enviousness", "epidemic", "equivocal", "erase", "erode", "erodes", "erosion", "err", "errant", "erratic", "erratically", "erroneous", "erroneously", "error", "errors", "eruptions", "estranged", "evade", "evasion", "evasive", "evil", "evildoer", "evils", "eviscerate", "exacerbate", "exaggerate", "exaggeration", "exasperate", "exasperated", "exasperating", "exasperatingly", "exasperation", "excessive", "excessively", "exclusion", "excoriate", "excruciating", "excruciatingly", "excuse", "excuses", "execrate", "exhaust", "exhausted", "exhaustion", "exhausts", "exhort", "exile", "exorbitant", "exorbitantly", "expel", "expensive", "expire", "expired", "explode", "exploit", "exploitation", "explosive", "expropriate", "expropriation", "expulse", "expunge", "exterminate", "extermination", "extinguish", "extort", "extortion", "extraneous", "extravagance", "extravagant", "extravagantly", "extremism", "extremist", "extremists", "eyesore", "fuck", "fabricate", "fabrication", "facetious", "facetiously", "fail", "failed", "failing", "fails", "failure", "failures", "faint", "fainthearted", "faithless", "fake", "fall", "fallacies", "fallacious", "fallaciously", "fallaciousness", "fallacy", "fallen", "falling", "fallout", "falls", "falsehood", "falsely", "falsify", "falter", "faltered", "famine", "famished", "fanatic", "fanatical", "fanatically", "fanaticism", "fanatics", "fanciful", "far-fetched", "farce", "farcical", "farcical-yet-provocative", "farcically", "farfetched", "fascism", "fascist", "fastidious", "fastidiously", "fat", "fat-cat", "fat-cats", "fatal", "fatalistic", "fatalistically", "fatally", "fateful", "fatefully", "fathomless", "fatigue", "fatigued", "fatty", "fatuity", "fatuous", "fatuously", "fault", "faults", "faulty", "fawningly", "faze", "fear", "fearful", "fearfully", "fears", "fearsome", "feckless", "feeble", "feebleminded", "feign", "feint", "fell", "felon", "felonious", "ferociously", "ferocity", "fetid", "fever", "feverish", "fevers", "fiasco", "fib", "fibber", "fickle", "fidget", "fidgety", "fiend", "fiendish", "fierce", "figurehead", "filth", "filthy", "finagle", "finicky", "fissures", "fist", "flabbergast", "flabbergasted", "flagging", "flagrant", "flagrantly", "flair", "flairs", "flak", "flake", "flakey", "flaking", "flaky", "flare", "flares", "flat-out", "flaunt", "flaw", "flawed", "flaws", "flee", "fleeing", "fleer", "flees", "fleeting", "flicker", "flickering", "flickers", "flighty", "flimflam", "flimsy", "flirt", "flirty", "floored", "flounder", "floundering", "flout", "fluster", "foe", "fool", "fooled", "foolhardy", "foolish", "foolishly", "foolishness", "forbid", "forbidden", "forbidding", "forceful", "foreboding", "forebodingly", "forfeit", "forged", "forgetful", "forgetfully", "forgetfulness", "forlorn", "forlornly", "forsake", "forsaken", "forswear", "foul", "foully", "foulness", "fractious", "fractiously", "fracture", "fragile", "fragmented", "frail", "frantic", "frantically", "franticly", "fraud", "fraudulent", "fraught", "frazzle", "frazzled", "freak", "freaking", "freakish", "freakishly", "freaks", "freeze", "freezes", "freezing", "frenetic", "frenetically", "frenzied", "frenzy", "fret", "fretful", "frets", "friction", "frictions", "fried", "frigging", "fright", "frighten", "frightening", "frighteningly", "frightful", "frightfully", "frigid", "frost", "frown", "froze", "frozen", "fruitless", "fruitlessly", "frustrate", "frustrated", "frustrates", "frustrating", "frustratingly", "frustration", "frustrations", "fuck", "fucking", "fudge", "fugitive", "full-blown", "fulminate", "fumble", "fume", "fumes", "fundamentalism", "funky", "furious", "furiously", "furor", "fury", "fuss", "fussy", "fustigate", "fusty", "futile", "futilely", "futility", "fuzzy", "gabble", "gaff", "gaffe", "gainsay", "gainsayer", "gall", "galling", "gallingly", "galls", "gangster", "gape", "garbage", "garish", "gasp", "gauche", "gaudy", "gawk", "gawky", "geezer", "genocide", "get-rich", "ghastly", "ghetto", "ghosting", "gibber", "gibberish", "gibe", "giddy", "gimmick", "gimmicked", "gimmicking", "gimmicks", "gimmicky", "glare", "glaringly", "glib", "glibly", "glitch", "glitches", "gloatingly", "gloom", "gloomy", "glower", "glum", "glut", "gnawing", "goad", "goading", "god-awful", "goon", "gossip", "graceless", "gracelessly", "graft", "grainy", "grapple", "grate", "grating", "gravely", "greasy", "greed", "greedy", "grief", "grievance", "grievances", "grieve", "grieving", "grievous", "grievously", "grim", "grimace", "grind", "gripe", "gripes", "grisly", "gritty", "gross", "grossly", "grotesque", "grouch", "grouchy", "groundless", "grouse", "growl", "grudge", "grudges", "grudging", "grudgingly", "gruesome", "gruesomely", "gruff", "grumble", "grumpier", "grumpiest", "grumpily", "grumpy", "guile", "guilt", "guiltily", "guilty", "gullible", "gutless", "gutter", "hack", "hacks", "haggard", "haggle", "halfhearted", "halfheartedly", "hallucinate", "hallucination", "hamper", "hampered", "handicapped", "hang", "hangs", "haphazard", "hapless", "harangue", "harass", "harassed", "harasses", "harassment", "harboring", "harbors", "hard", "hard-hit", "hard-liner", "hardball", "harden", "hardened", "hardheaded", "hardhearted", "hardliner", "hardliners", "hardship", "hardships", "harm", "harmed", "harmful", "harms", "harpy", "harridan", "harried", "harrow", "harsh", "harshly", "hassle", "hassled", "hassles", "haste", "hastily", "hasty", "hate", "hated", "hateful", "hatefully", "hatefulness", "hater", "haters", "hates", "hating", "hatred", "haughtily", "haughty", "haunt", "haunting", "havoc", "hawkish", "haywire", "hazard", "hazardous", "haze", "hazy", "head-aches", "headache", "headaches", "heartbreaker", "heartbreaking", "heartbreakingly", "heartless", "heathen", "heavy-handed", "heavyhearted", "heck", "heckle", "heckled", "heckles", "hectic", "hedge", "hedonistic", "heedless", "hefty", "hegemony", "heinous", "hell", "hell-bent", "hellion", "hells", "helpless", "helplessly", "helplessness", "heresy", "heretic", "heretical", "hesitant", "hideous", "hideously", "hideousness", "high-priced", "hinder", "hindrance", "hiss", "hissed", "hissing", "ho-hum", "hoard", "hoax", "hobble", "hogs", "hollow", "hoodwink", "hooligan", "hopeless", "hopelessly", "hopelessness", "horde", "horrendous", "horrendously", "horrible", "horrid", "horrific", "horrified", "horrifies", "horrify", "horrifying", "hostage", "hostile", "hostilities", "hostility", "hotbeds", "hothead", "hotheaded", "hothouse", "hubris", "huckster", "humid", "humiliate", "humiliating", "humiliation", "humming", "hung", "hurt", "hurtful", "hurting", "hurts", "hustler", "hype", "hypocrisy", "hypocrite", "hypocrites", "hypocritical", "hypocritically", "hysteria", "hysteric", "hysterical", "hysterically", "hysterics", "idiocies", "idiocy", "idiot", "idiotic", "idiotically", "idiots", "idle", "ignoble", "ignominious", "ignominiously", "ignominy", "ignorance", "ignorant", "ignore", "ill-advised", "ill-conceived", "ill-defined", "ill-designed", "ill-fated", "ill-favored", "ill-formed", "ill-mannered", "ill-natured", "ill-sorted", "ill-tempered", "ill-treated", "ill-treatment", "ill-usage", "ill-used", "illegal", "illegally", "illegitimate", "illicit", "illiterate", "illness", "illogical", "illogically", "illusion", "illusions", "illusory", "imaginary", "imbalance", "imbecile", "imbroglio", "immaterial", "immature", "imminence", "imminently", "immobilized", "immoderate", "immoderately", "immodest", "immoral", "immorality", "immorally", "immovable", "impair", "impaired", "impasse", "impatience", "impatient", "impatiently", "impeach", "impedance", "impede", "impediment", "impending", "impenitent", "imperfect", "imperfection", "imperfections", "imperfectly", "imperialist", "imperil", "imperious", "imperiously", "impermissible", "impersonal", "impertinent", "impetuous", "impetuously", "impiety", "impinge", "impious", "implacable", "implausible", "implausibly", "implicate", "implication", "implode", "impolite", "impolitely", "impolitic", "importunate", "importune", "impose", "imposers", "imposing", "imposition", "impossible", "impossibly", "impotent", "impoverish", "impoverished", "impractical", "imprecate", "imprecise", "imprecisely", "imprecision", "imprison", "imprisonment", "improbability", "improbable", "improbably", "improper", "improperly", "impropriety", "imprudence", "imprudent", "impudence", "impudent", "impudently", "impugn", "impulsive", "impulsively", "impunity", "impure", "impurity", "inability", "inaccuracies", "inaccuracy", "inaccurate", "inaccurately", "inaction", "inactive", "inadequacy", "inadequate", "inadequately", "inadvisable", "inane", "inanely", "inappropriate", "inappropriately", "inapt", "inarticulate", "inattentive", "inaudible", "incapable", "incapably", "incautious", "incendiary", "incense", "incessant", "incessantly", "incite", "incitement", "incivility", "inclement", "incoherence", "incoherent", "incoherently", "incommensurate", "incomparable", "incomparably", "incompatibility", "incompatible", "incompetence", "incompetent", "incompetently", "incomplete", "incomprehensible", "incomprehension", "inconceivable", "inconceivably", "incongruous", "incongruously", "inconsequential", "inconsequentially", "inconsiderate", "inconsiderately", "inconsistencies", "inconsistency", "inconsistent", "inconsolable", "inconsolably", "inconstant", "inconvenience", "inconveniently", "incorrect", "incorrectly", "incorrigible", "incorrigibly", "incredulous", "incredulously", "inculcate", "indecency", "indecent", "indecently", "indecision", "indecisive", "indecisively", "indefensible", "indelicate", "indeterminable", "indeterminably", "indeterminate", "indifference", "indifferent", "indigent", "indignant", "indignantly", "indignation", "indignity", "indiscernible", "indiscreet", "indiscreetly", "indiscretion", "indiscriminate", "indiscriminately", "indistinguishable", "indoctrinate", "indoctrination", "indolent", "indulge", "ineffective", "ineffectively", "ineffectiveness", "ineffectual", "ineffectually", "inefficacy", "inefficiency", "inefficient", "inefficiently", "inelegance", "inelegant", "ineligible", "inept", "ineptitude", "ineptly", "inequalities", "inequality", "inequitable", "inequitably", "inequities", "inescapable", "inescapably", "inessential", "inevitable", "inevitably", "inexcusable", "inexcusably", "inexorable", "inexorably", "inexperience", "inexperienced", "inexpert", "inexpertly", "inexpiable", "inextricable", "inextricably", "infamous", "infamously", "infamy", "infected", "infection", "infections", "inferior", "inferiority", "infernal", "infest", "infested", "infidel", "infidels", "infiltrator", "infiltrators", "infirm", "inflame", "inflammation", "inflammatory", "inflated", "inflationary", "inflexible", "inflict", "infraction", "infringe", "infringement", "infringements", "infuriate", "infuriated", "infuriating", "infuriatingly", "inglorious", "ingrate", "ingratitude", "inhibit", "inhibition", "inhospitable", "inhuman", "inhumane", "inhumanity", "inimical", "inimically", "iniquitous", "iniquity", "injudicious", "injure", "injurious", "injury", "injustice", "injustices", "innuendo", "inoperable", "inopportune", "inordinate", "inordinately", "insane", "insanely", "insanity", "insatiable", "insecure", "insecurity", "insensible", "insensitive", "insensitively", "insensitivity", "insidious", "insidiously", "insignificance", "insignificant", "insignificantly", "insincere", "insincerely", "insincerity", "insinuate", "insinuating", "insinuation", "insolence", "insolent", "insolently", "insolvent", "insouciance", "instability", "instigate", "instigator", "instigators", "insubordinate", "insubstantial", "insubstantially", "insufferable", "insufferably", "insufficiency", "insufficient", "insufficiently", "insular", "insult", "insulted", "insulting", "insultingly", "insults", "insupportable", "insurmountable", "insurmountably", "insurrection", "intense", "interfere", "interference", "interferes", "intermittent", "interrupt", "interruption", "interruptions", "intimidate", "intimidating", "intimidatingly", "intimidation", "intolerable", "intolerance", "intoxicate", "intractable", "intransigence", "intransigent", "intrude", "intrusion", "intrusive", "inundate", "inundated", "invader", "invalid", "invalidate", "invalidity", "invasive", "invective", "inveigle", "invidious", "invidiously", "invidiousness", "invisible", "involuntarily", "involuntary", "irascible", "irate", "irately", "ire", "irk", "irked", "irking", "irks", "irksome", "irksomely", "irksomeness", "ironic", "ironical", "ironically", "ironies", "irony", "irrational", "irrationality", "irrationally", "irrationals", "irreconcilable", "irrecoverable", "irrecoverably", "irredeemable", "irredeemably", "irregular", "irregularity", "irrelevance", "irrelevant", "irreparable", "irrepressible", "irresolute", "irresponsible", "irresponsibly", "irretrievable", "irreversible", "irritable", "irritably", "irritant", "irritate", "irritated", "irritating", "irritation", "irritations", "isolate", "isolated", "isolation", "issue", "issues", "itch", "itching", "itchy", "jabber", "jaded", "jagged", "jam", "jarring", "jaundiced", "jealous", "jealously", "jealousness", "jealousy", "jeer", "jeering", "jeeringly", "jeers", "jeopardize", "jeopardy", "jerk", "jerky", "jitter", "jitters", "jittery", "job-killing", "jobless", "joke", "joker", "jolt", "judder", "juddering", "judders", "jumpy", "junk", "junky", "junkyard", "kill", "killed", "killer", "killing", "killjoy", "kills", "knave", "knife", "knock", "knotted", "kook", "kooky", "lack", "lackadaisical", "lacked", "lackey", "lackeys", "lacking", "lackluster", "lacks", "laconic", "lag", "lagged", "lagging", "lags", "laid-off", "lambast", "lambaste", "lame", "lame-duck", "lament", "lamentable", "lamentably", "languid", "languish", "languor", "languorous", "languorously", "lanky", "lapse", "lapsed", "lapses", "lascivious", "last-ditch", "latency", "laughable", "laughably", "laughingstock", "lawbreaker", "lawbreaking", "lawless", "lawlessness", "layoff", "layoff-happy", "lazy", "leak", "leakage", "leakages", "leaking", "leaks", "leaky", "lecher", "lecherous", "lechery", "leech", "leer", "leery", "left-leaning", "lemon", "lengthy", "less-developed", "lesser-known", "letch", "lethal", "lethargic", "lethargy", "lewd", "lewdly", "lewdness", "liability", "liable", "liar", "liars", "licentious", "licentiously", "licentiousness", "lie", "lied", "lies", "life-threatening", "lifeless", "limit", "limitation", "limitations", "limited", "limits", "limp", "listless", "litigious", "little-known", "livid", "lividly", "loath", "loathe", "loathing", "loathly", "loathsome", "loathsomely", "lone", "loneliness", "lonely", "loner", "lonesome", "long-time", "long-winded", "longing", "longingly", "loophole", "loopholes", "loose", "loot", "lose", "loser", "losers", "loses", "losing", "loss", "losses", "lost", "loud", "louder", "lousy", "loveless", "lovelorn", "low-rated", "lowly", "ludicrous", "ludicrously", "lugubrious", "lukewarm", "lull", "lumpy", "lunatic", "lurch", "lure", "lurid", "lurk", "lurking", "lying", "macabre", "mad", "madden", "maddening", "maddeningly", "madder", "madly", "madman", "madness", "maladjusted", "maladjustment", "malady", "malaise", "malcontent", "malcontented", "maledict", "malevolence", "malevolent", "malevolently", "malice", "malicious", "maliciously", "maliciousness", "malign", "malignant", "malodorous", "maltreatment", "mangle", "mangled", "mangles", "mangling", "mania", "maniac", "maniacal", "manic", "manipulate", "manipulation", "manipulative", "manipulators", "mar", "marginal", "marginally", "martyrdom", "martyrdom-seeking", "mashed", "massacre", "massacres", "matte", "mawkish", "mawkishly", "mawkishness", "meager", "meaningless", "meanness", "measly", "meddle", "meddlesome", "mediocre", "mediocrity", "melancholy", "melodramatic", "melodramatically", "meltdown", "menace", "menacing", "menacingly", "mendacious", "mendacity", "menial", "merciless", "mercilessly", "mess", "messed", "messes", "messing", "messy", "midget", "miff", "militancy", "mindless", "mindlessly", "mirage", "mire", "misalign", "misaligned", "misaligns", "misapprehend", "misbecome", "misbecoming", "misbegotten", "misbehave", "misbehavior", "miscalculate", "miscalculation", "miscellaneous", "mischief", "mischievous", "mischievously", "misconception", "misconceptions", "miscreant", "miscreants", "misdirection", "miser", "miserable", "miserableness", "miserably", "miseries", "miserly", "misery", "misfit", "misfortune", "misgiving", "misgivings", "misguidance", "misguide", "misguided", "mishandle", "mishap", "misinform", "misinformed", "misinterpret", "misjudge", "misjudgment", "mislead", "misleading", "misleadingly", "mismanage", "mispronounce", "mispronounced", "mispronounces", "misread", "misreading", "misrepresent", "misrepresentation", "miss", "missed", "misses", "misstatement", "mist", "mistake", "mistaken", "mistakenly", "mistakes", "mistress", "mistrust", "mistrustful", "mistrustfully", "mists", "misunderstand", "misunderstanding", "misunderstandings", "misunderstood", "misuse", "moan", "mobster", "mock", "mocked", "mockeries", "mockery", "mocking", "mockingly", "mocks", "molest", "molestation", "monotonous", "monotony", "monster", "monstrosities", "monstrosity", "monstrous", "monstrously", "moody", "moot", "mope", "morbid", "morbidly", "mordant", "mordantly", "moribund", "moron", "moronic", "morons", "mortification", "mortified", "mortify", "mortifying", "motionless", "motley", "mourn", "mourner", "mournful", "mournfully", "muddle", "muddy", "mudslinger", "mudslinging", "mulish", "multi-polarization", "mundane", "murder", "murderer", "murderous", "murderously", "murky", "muscle-flexing", "mushy", "musty", "mysterious", "mysteriously", "mystery", "mystify", "myth", "nag", "nagging", "naive", "naively", "narrower", "nastily", "nastiness", "nasty", "naughty", "nauseate", "nauseates", "nauseating", "nauseatingly", "naïve", "nebulous", "nebulously", "needless", "needlessly", "needy", "nefarious", "nefariously", "negate", "negation", "negative", "negatives", "negativity", "neglect", "neglected", "negligence", "negligent", "nemesis", "nepotism", "nervous", "nervously", "nervousness", "nettle", "nettlesome", "neurotic", "neurotically", "niggle", "niggles", "nightmare", "nightmarish", "nightmarishly", "nitpick", "nitpicking", "noise", "noises", "noisier", "noisy", "non-confidence", "nonexistent", "nonresponsive", "nonsense", "nosey", "notoriety", "notorious", "notoriously", "noxious", "nuisance", "numb", "obese", "object", "objection", "objectionable", "objections", "oblique", "obliterate", "obliterated", "oblivious", "obnoxious", "obnoxiously", "obscene", "obscenely", "obscenity", "obscure", "obscured", "obscures", "obscurity", "obsess", "obsessive", "obsessively", "obsessiveness", "obsolete", "obstacle", "obstinate", "obstinately", "obstruct", "obstructed", "obstructing", "obstruction", "obstructs", "obtrusive", "obtuse", "occlude", "occluded", "occludes", "occluding", "odd", "odder", "oddest", "oddities", "oddity", "oddly", "odor", "offence", "offend", "offender", "offending", "offenses", "offensive", "offensively", "offensiveness", "officious", "ominous", "ominously", "omission", "omit", "one-sided", "onerous", "onerously", "onslaught", "opinionated", "opponent", "opportunistic", "oppose", "opposition", "oppositions", "oppress", "oppression", "oppressive", "oppressively", "oppressiveness", "oppressors", "ordeal", "orphan", "ostracize", "outbreak", "outburst", "outbursts", "outcast", "outcry", "outlaw", "outmoded", "outrage", "outraged", "outrageous", "outrageously", "outrageousness", "outrages", "outsider", "over-acted", "over-awe", "over-balanced", "over-hyped", "over-priced", "over-valuation", "overact", "overacted", "overawe", "overbalance", "overbalanced", "overbearing", "overbearingly", "overblown", "overdo", "overdone", "overdue", "overemphasize", "overheat", "overkill", "overloaded", "overlook", "overpaid", "overplay", "overpower", "overpriced", "overrated", "overreach", "overrun", "overshadow", "oversight", "oversights", "oversimplification", "oversimplified", "oversimplify", "oversize", "overstate", "overstated", "overstatement", "overstatements", "overstates", "overtaxed", "overthrow", "overthrows", "overturn", "overweight", "overwhelm", "overwhelmed", "overwhelming", "overwhelmingly", "overwhelms", "overzealous", "overzealously", "pain", "painful", "painfully", "pains", "pale", "pales", "paltry", "pan", "pandemonium", "pander", "pandering", "panders", "panic", "panicked", "panicking", "panicky", "paradoxical", "paradoxically", "paralyzed", "paranoia", "paranoid", "parasite", "pariah", "parody", "partiality", "partisan", "partisans", "passive", "passiveness", "pathetic", "pathetically", "patronize", "paucity", "pauper", "paupers", "payback", "peculiar", "peculiarly", "pedantic", "peeled", "peeve", "peeved", "peevish", "peevishly", "penalize", "penalty", "perfidious", "perfunctory", "peril", "perilous", "perilously", "perish", "pernicious", "perplex", "perplexed", "perplexing", "perplexity", "persecute", "persecution", "pertinacious", "pertinaciously", "pertinacity", "perturb", "perturbed", "pervasive", "perverse", "perversely", "perversion", "perversity", "pervert", "perverted", "perverts", "pessimism", "pessimistic", "pessimistically", "pest", "pestilent", "petrified", "petrify", "pettifog", "petty", "phobia", "phobic", "phony", "picket", "picketed", "picketing", "pickets", "picky", "pig", "pigs", "pillage", "pillory", "pimple", "pinch", "pique", "pitiable", "pitiful", "pitifully", "pitiless", "pitilessly", "pittance", "pity", "plagiarize", "plague", "plaything", "plea", "pleas", "plebeian", "plight", "plot", "plotters", "ploy", "plunder", "plunderer", "pointless", "pointlessly", "poison", "poisonous", "poisonously", "pokey", "poky", "pollute", "polluter", "polluters", "pompous", "poor", "poorer", "poorest", "poorly", "posturing", "pout", "poverty", "powerless", "prate", "pratfall", "prattle", "precarious", "precariously", "precipitate", "precipitous", "predatory", "predicament", "prejudge", "prejudice", "prejudices", "prejudicial", "premeditated", "preoccupy", "preposterous", "preposterously", "presumptuous", "presumptuously", "pretend", "pretense", "pretentious", "pretentiously", "prevaricate", "pricey", "pricier", "prick", "prickle", "prickles", "prideful", "primitive", "prison", "prisoner", "problem", "problematic", "problems", "procrastinate", "procrastinates", "procrastination", "profane", "profanity", "prohibit", "prohibitive", "prohibitively", "propaganda", "propagandize", "proprietary", "prosecute", "protest", "protested", "protesting", "protests", "protracted", "provocation", "provocative", "provoke", "pry", "pugnacious", "pugnaciously", "pugnacity", "punch", "punish", "punishable", "punitive", "punk", "puny", "puppet", "puppets", "puzzled", "puzzlement", "puzzling", "quack", "qualm", "qualms", "quandary", "quarrel", "quarrels", "quarrelsome", "quash", "queer", "questionable", "quibble", "quibbles", "quitter", "rabid", "racism", "racist", "racists", "racy", "radical", "radicalization", "radically", "radicals", "rage", "ragged", "raging", "rail", "raked", "rampage", "rampant", "ramshackle", "rancor", "randomly", "rankle", "rant", "ranted", "ranting", "rants", "rape", "raped", "raping", "rascal", "rascals", "rash", "rattle", "rattled", "rattles", "ravage", "raving", "reactionary", "rebellious", "rebuff", "rebuke", "recalcitrant", "recant", "recession", "recessionary", "reckless", "recklessly", "recklessness", "recoil", "recourses", "redundancy", "redundant", "refusal", "refuse", "refused", "refuses", "refusing", "refutation", "refute", "refuted", "refutes", "refuting", "regress", "regression", "regressive", "regret", "regretful", "regretfully", "regrets", "regrettable", "regrettably", "regretted", "reject", "rejected", "rejecting", "rejection", "rejects", "relapse", "relentless", "relentlessly", "relentlessness", "reluctance", "reluctant", "reluctantly", "remorse", "remorseful", "remorsefully", "remorseless", "remorselessly", "remorselessness", "renounce", "renunciation", "repel", "repetitive", "reprehensible", "reprehensibly", "reprehension", "reprehensive", "repress", "repression", "repressive", "reprimand", "reproach", "reproachful", "reprove", "reprovingly", "repudiate", "repudiation", "repugnance", "repugnant", "repugnantly", "repulse", "repulsed", "repulsing", "repulsive", "repulsively", "repulsiveness", "resent", "resentful", "resentment", "resignation", "resigned", "resistance", "restless", "restlessness", "restrict", "restricted", "restriction", "restrictive", "resurgent", "retaliate", "retaliatory", "retard", "retarded", "retards", "reticent", "retract", "retreat", "retreated", "revenge", "revengeful", "revengefully", "revert", "revile", "reviled", "revoke", "revolt", "revolting", "revoltingly", "revulsion", "revulsive", "rhapsodize", "rhetoric", "rhetorical", "ridicule", "ridicules", "ridiculous", "ridiculously", "rife", "rift", "rifts", "rigid", "rigidity", "rigidness", "rile", "riled", "rip", "rip-off", "ripped", "risk", "risks", "risky", "rival", "rivalry", "roadblocks", "rocky", "rogue", "rollercoaster", "rot", "rotten", "rough", "rubbish", "rude", "rue", "ruffian", "ruin", "ruined", "ruining", "ruinous", "ruins", "rumbling", "rumor", "rumors", "rumple", "run-down", "runaway", "rupture", "rust", "rusts", "rusty", "rut", "ruthless", "ruthlessly", "ruthlessness", "ruts", "sabotage", "sack", "sacrificed", "sad", "sadden", "sadly", "sadness", "sag", "sagged", "sagging", "saggy", "sags", "salacious", "sanctimonious", "sap", "sarcasm", "sarcastic", "sarcastically", "sardonic", "sardonically", "sass", "satirical", "satirize", "savage", "savaged", "savagery", "savages", "scaly", "scam", "scams", "scandal", "scandalize", "scandalized", "scandalous", "scandalously", "scandals", "scant", "scapegoat", "scar", "scare", "scared", "scarier", "scariest", "scarily", "scarred", "scars", "scary", "scathing", "scathingly", "scoff", "scold", "scolded", "scolding", "scorching", "scorn", "scornful", "scornfully", "scoundrel", "scourge", "scowl", "scramble", "scrambled", "scrambles", "scrambling", "scrap", "scratch", "scratched", "scratches", "scratchy", "scream", "screech", "screw-up", "screwed", "screwed-up", "screwy", "scuff", "scuffs", "scum", "scummy", "second-class", "second-tier", "secretive", "sedentary", "seedy", "seethe", "seething", "self-coup", "self-criticism", "self-defeating", "self-destructive", "self-humiliation", "self-interest", "self-interested", "self-serving", "selfish", "selfishly", "selfishness", "semi-retarded", "senile", "sensationalize", "senseless", "senselessly", "seriousness", "sermonize", "servitude", "set-up", "setback", "setbacks", "sever", "severe", "severity", "shabby", "shadowy", "shady", "shake", "shaky", "shallow", "sham", "shambles", "shame", "shameful", "shamefully", "shamefulness", "shameless", "shamelessly", "shamelessness", "shark", "sharply", "shatter", "shimmer", "shimmy", "shipwreck", "shirk", "shirker", "shit", "shiver", "shock", "shocked", "shocking", "shockingly", "shoddy", "short-lived", "shortage", "shortchange", "shortcoming", "shortcomings", "shortness", "shortsighted", "shortsightedness", "showdown", "shrew", "shriek", "shrill", "shrilly", "shrivel", "shroud", "shrouded", "shrug", "shun", "shunned", "sick", "sicken", "sickening", "sickeningly", "sickly", "sickness", "sidetrack", "sidetracked", "siege", "silly", "simplistic", "simplistically", "sin", "sinful", "sinfully", "sinister", "sinisterly", "sink", "sinking", "skeletons", "skeptic", "skeptical", "skeptically", "skepticism", "sketchy", "skimpy", "skinny", "skittish", "skittishly", "skulk", "slack", "slander", "slanderer", "slanderous", "slanderously", "slanders", "slap", "slashing", "slaughter", "slaughtered", "slave", "slaves", "sleazy", "slime", "slog", "slogged", "slogging", "slogs", "sloppily", "sloppy", "sloth", "slothful", "slow", "slow-moving", "slowed", "slower", "slowest", "slowly", "slug", "sluggish", "slump", "slumping", "slur", "slut", "sluts", "sly", "smack", "smallish", "smash", "smear", "smell", "smelled", "smelling", "smells", "smelly", "smelt", "smoke", "smokescreen", "smolder", "smoldering", "smother", "smudge", "smudged", "smudges", "smudging", "smug", "smugly", "smut", "smuttier", "smuttiest", "smutty", "snag", "snagged", "snagging", "snags", "snappish", "snappishly", "snare", "snarky", "snarl", "sneak", "sneakily", "sneaky", "sneer", "sneering", "sneeringly", "snob", "snobbish", "snobby", "snobs", "snub", "soapy", "sob", "sober", "sobering", "solemn", "solicitude", "somber", "sore", "sorely", "soreness", "sorrow", "sorrowful", "sorrowfully", "sorry", "sour", "sourly", "spade", "spank", "spew", "spewed", "spewing", "spews", "spilling", "spinster", "spiritless", "spite", "spiteful", "spitefully", "spitefulness", "splatter", "split", "splitting", "spoil", "spoilage", "spoilages", "spoiled", "spoils", "spook", "spookier", "spookiest", "spookily", "spooky", "spoon-fed", "spoon-feed", "sporadic", "spotty", "spurious", "spurn", "sputter", "squabble", "squabbling", "squander", "squash", "squeak", "squeaks", "squeaky", "squeal", "squealing", "squeals", "squirm", "stab", "stagnant", "stagnate", "stagnation", "staid", "stain", "stains", "stale", "stalemate", "stall", "stalls", "stammer", "stampede", "standstill", "stark", "starkly", "startle", "startling", "startlingly", "starvation", "starve", "static", "steal", "stealing", "steals", "steep", "steeply", "stench", "stereotype", "stereotypical", "stereotypically", "stern", "stew", "sticky", "stiff", "stiffness", "stifle", "stifling", "stiflingly", "stigma", "stigmatize", "sting", "stinging", "stingingly", "stingy", "stink", "stinks", "stodgy", "stole", "stolen", "stooge", "stooges", "stormy", "straggle", "straggler", "strain", "strained", "straining", "strange", "strangely", "stranger", "strangest", "strangle", "streaky", "strenuous", "stress", "stresses", "stressful", "stressfully", "stricken", "strict", "strictly", "strident", "stridently", "strife", "strike", "stringent", "stringently", "struck", "struggle", "struggled", "struggles", "struggling", "strut", "stubborn", "stubbornly", "stubbornness", "stuck", "stuffy", "stumble", "stumbled", "stumbles", "stump", "stumped", "stumps", "stun", "stunt", "stunted", "stupid", "stupidest", "stupidity", "stupidly", "stupor", "stutter", "stuttered", "stuttering", "stutters", "sty", "stymied", "sub-par", "subdued", "subjected", "subjection", "subjugate", "subjugation", "submissive", "subordinate", "subpoena", "subpoenas", "subservience", "subservient", "substandard", "subtract", "subversion", "subversive", "subversively", "subvert", "succumb", "suck", "sucked", "sucker", "sucks", "sucky", "sue", "sued", "sues", "suffer", "suffered", "sufferer", "sufferers", "suffering", "suffers", "suffocate", "sugar-coat", "sugar-coated", "sugarcoated", "suicidal", "suicide", "sulk", "sullen", "sully", "sunder", "sunk", "sunken", "superficial", "superficiality", "superficially", "superfluous", "superstition", "superstitious", "suppress", "suppression", "surrender", "susceptible", "suspect", "suspicion", "suspicions", "suspicious", "suspiciously", "swagger", "swamped", "sweaty", "swelled", "swelling", "swindle", "swipe", "swollen", "symptom", "symptoms", "syndrome", "taboo", "tacky", "taint", "tainted", "tamper", "tangle", "tangled", "tangles", "tank", "tanked", "tanks", "tantrum", "tardy", "tarnish", "tarnished", "tarnishes", "tarnishing", "tattered", "taunt", "taunting", "tauntingly", "taunts", "taut", "tawdry", "taxing", "tease", "teasingly", "tedious", "tediously", "temerity", "temper", "tempest", "temptation", "tenderness", "tense", "tension", "tentative", "tentatively", "tepid", "terrible", "terribleness", "terror", "terror-genic", "terrorism", "terrorize", "testily", "testy", "tetchily", "tetchy", "thankless", "thicker", "thirst", "thorny", "thoughtless", "thoughtlessly", "thoughtlessness", "thrash", "threat", "threaten", "threatening", "threats", "threesome", "throb", "throbbed", "throbbing", "throbs", "throttle", "thug", "thumb-down", "thumbs-down", "thwart", "time-consuming", "timid", "timidity", "timidly", "tin-y", "tingled", "tingling", "tired", "tiresome", "tiring", "tiringly", "toil", "toll", "top-heavy", "topple", "torment", "tormented", "torrent", "tortuous", "torture", "tortured", "tortures", "torturing", "torturous", "torturously", "totalitarian", "touchy", "toughness", "tout", "touted", "touts", "toxic", "traduce", "tragedy", "tragic", "tragically", "traitor", "traitorous", "traitorously", "tramp", "trample", "transgress", "transgression", "trap", "trapped", "trash", "trashed", "trashy", "trauma", "traumatic", "traumatically", "traumatize", "traumatized", "travesties", "travesty", "treacherous", "treacherously", "treachery", "treason", "treasonous", "trick", "tricked", "trickery", "tricky", "trivial", "trivialize", "trouble", "troubled", "troublemaker", "troubles", "troublesome", "troublesomely", "troubling", "troublingly", "truant", "tumble", "tumbled", "tumbles", "tumultuous", "turbulent", "turmoil", "twist", "twisted", "twists", "two-faced", "two-faces", "tyrannical", "tyrannically", "tyranny", "tyrant", "ugh", "uglier", "ugliest", "ugliness", "ugly", "ulterior", "ultimatum", "ultimatums", "ultra-hardline", "un-viewable", "unable", "unacceptable", "unacceptably", "unaccustomed", "unachievable", "unaffordable", "unappealing", "unattractive", "unauthentic", "unavailable", "unavoidably", "unbearable", "unbelievable", "unbelievably", "uncaring", "uncertain", "uncivil", "uncivilized", "unclean", "unclear", "uncollectible", "uncomfortable", "uncomfortably", "uncompetitive", "uncompromising", "uncompromisingly", "unconfirmed", "unconstitutional", "uncontrolled", "unconvincing", "unconvincingly", "uncooperative", "uncouth", "uncreative", "undecided", "undefined", "undependability", "undependable", "undercut", "undercuts", "undercutting", "underdog", "underestimate", "underlings", "undermine", "undermined", "undermines", "undermining", "underpaid", "underpowered", "undersized", "undesirable", "undetermined", "undid", "undignified", "undissolved", "undocumented", "undone", "undue", "unease", "uneasily", "uneasiness", "uneasy", "uneconomical", "unemployed", "unequal", "unethical", "uneven", "uneventful", "unexpected", "unexpectedly", "unexplained", "unfairly", "unfaithful", "unfaithfully", "unfamiliar", "unfavorable", "unfeeling", "unfinished", "unfit", "unforeseen", "unforgiving", "unfortunate", "unfortunately", "unfounded", "unfriendly", "unfulfilled", "unfunded", "ungovernable", "ungrateful", "unhappily", "unhappiness", "unhappy", "unhealthy", "unhelpful", "unilateralism", "unimaginable", "unimaginably", "unimportant", "uninformed", "uninsured", "unintelligible", "unipolar", "unjust", "unjustifiable", "unjustifiably", "unjustified", "unjustly", "unkind", "unkindly", "unknown", "unlawful", "unlawfully", "unlawfulness", "unleash", "unlicensed", "unlikely", "unlucky", "unmoved", "unnatural", "unnaturally", "unnecessary", "unneeded", "unnerve", "unnerved", "unnerving", "unnervingly", "unnoticed", "unobserved", "unorthodox", "unorthodoxy", "unpleasant", "unpopular", "unpredictable", "unprepared", "unproductive", "unprofitable", "unproved", "unproven", "unqualified", "unravel", "unraveled", "unreachable", "unreadable", "unrealistic", "unreasonable", "unreasonably", "unrelenting", "unrelentingly", "unreliability", "unreliable", "unresolved", "unresponsive", "unrest", "unruly", "unsafe", "unsatisfactory", "unsavory", "unscrupulous", "unscrupulously", "unsecure", "unseemly", "unsettle", "unsettled", "unsettling", "unsettlingly", "unskilled", "unsophisticated", "unsound", "unspeakable", "unspecified", "unstable", "unsteadily", "unsteadiness", "unsteady", "unsuccessful", "unsuccessfully", "unsupported", "unsupportive", "unsure", "unsuspecting", "unsustainable", "untenable", "untested", "unthinkable", "unthinkably", "untimely", "untouched", "untrue", "untrustworthy", "untruthful", "unusable", "unusably", "unusual", "unusually", "unwanted", "unwarranted", "unwatchable", "unwelcome", "unwell", "unwieldy", "unwilling", "unwillingly", "unwillingness", "unwise", "unwisely", "unworkable", "unworthy", "unyielding", "upbraid", "upheaval", "uprising", "uproar", "uproarious", "uproariously", "uproot", "upset", "upsets", "upsetting", "upsettingly", "urgent", "useless", "usurp", "usurper", "utterly", "vagrant", "vague", "vagueness", "vain", "vainly", "vanity", "vehement", "vehemently", "vengeance", "vengeful", "vengefully", "vengefulness", "venom", "venomous", "venomously", "vent", "vestiges", "vex", "vexation", "vexing", "vexingly", "vibrate", "vibrated", "vibrates", "vibrating", "vibration", "vice", "vicious", "viciously", "viciousness", "victimize", "vile", "vileness", "vilify", "villainous", "villainously", "villains", "vindictive", "vindictively", "vindictiveness", "violate", "violation", "violator", "violators", "violent", "violently", "viper", "virulence", "virulent", "virulently", "virus", "vociferous", "vociferously", "volatile", "volatility", "vomit", "vomited", "vomiting", "vomits", "vulgar", "vulnerable", "wail", "wallow", "wane", "waning", "wanton", "war-like", "warily", "wariness", "warlike", "warned", "warning", "warp", "warped", "wary", "washed-out", "waste", "wasted", "wasteful", "wastefulness", "wasting", "water-down", "watered-down", "wayward", "weak", "weaken", "weakening", "weaker", "weakness", "weaknesses", "weariness", "wearisome", "weary", "wedge", "weed", "weep", "wheedle", "whimper", "whine", "whining", "whiny", "whips", "whore", "whores", "wicked", "wickedly", "wickedness", "wild", "wildly", "wiles", "wilt", "wily", "wimpy", "wince", "wobble", "wobbled", "wobbles", "woe", "woebegone", "woeful", "woefully", "womanizer", "womanizing", "worn", "worried", "worriedly", "worrier", "worries", "worrisome", "worry", "worrying", "worryingly", "worse", "worsen", "worsening", "worst", "worthless", "worthlessly", "worthlessness", "wound", "wounds", "wrangle", "wrath", "wreak", "wreaked", "wreaks", "wreck", "wrest", "wrestle", "wretch", "wretched", "wretchedly", "wretchedness", "wrinkle", "wrinkled", "wrinkles", "writhe", "wrong", "wrongful", "wrongly", "wrought", "yawn", "zap", "zapped", "zaps", "zealot", "zealous", "zealously", "zombie"];

// Discard any sentences containing these words: shield your eyes! From the long list here: http://www.freewebheaders.com/full-list-of-bad-words-banned-by-google/
var offensiveWords =  ["4r5e", "50 yard cunt punt", "5h1t", "5hit", "a_s_s", "a2m", "a55", "adult", "amateur", "anal", "anal impaler", "anal leakage", "anilingus", "anus", "ar5e", "arrse", "arse", "arsehole", "ass", "ass fuck", "asses", "assfucker", "ass-fucker", "assfukka", "asshole", "asshole", "assholes", "assmucus", "assmunch", "asswhole", "autoerotic", "b!tch", "b00bs", "b17ch", "b1tch", "ballbag", "ballsack", "bang (one's) box", "bangbros", "bareback", "bastard", "beastial", "beastiality", "beef curtain", "bellend", "bestial", "bestiality", "bi+ch", "biatch", "bimbos", "birdlock", "bitch", "bitch tit", "bitcher", "bitchers", "bitches", "bitchin", "bitching", "bloody", "blow job", "blow me", "blow mud", "blowjob", "blowjobs", "blue waffle", "blumpkin", "boiolas", "bollock", "bollok", "boner", "boob", "boobs", "booobs", "boooobs", "booooobs", "booooooobs", "breasts", "buceta", "bugger", "bum", "bunny fucker", "bust a load", "busty", "butt", "butt fuck", "butthole", "buttmuch", "buttplug", "c0ck", "c0cksucker", "carpet muncher", "carpetmuncher", "cawk", "chink", "choade", "chota bags", "cipa", "cl1t", "clit", "clit licker", "clitoris", "clits", "clitty litter", "clusterfuck", "cnut", "cock", "cock pocket", "cock snot", "cockface", "cockhead", "cockmunch", "cockmuncher", "cocks", "cocksuck", "cocksucked", "cocksucker", "cock-sucker", "cocksucking", "cocksucks", "cocksuka", "cocksukka", "cok", "cokmuncher", "coksucka", "coon", "cop some wood", "cornhole", "corp whore", "cox", "cum", "cum chugger", "cum dumpster", "cum freak", "cum guzzler", "cumdump", "cummer", "cumming", "cums", "cumshot", "cunilingus", "cunillingus", "cunnilingus", "cunt", "cunt hair", "cuntbag", "cuntlick", "cuntlicker", "cuntlicking", "cunts", "cuntsicle", "cunt-struck", "cut rope", "cyalis", "cyberfuc", "cyberfuck", "cyberfucked", "cyberfucker", "cyberfuckers", "cyberfucking", "d1ck", "damn", "dick", "dick hole", "dick shy", "dickhead", "dildo", "dildos", "dink", "dinks", "dirsa", "dirty Sanchez", "dlck", "dog-fucker", "doggie style", "doggiestyle", "doggin", "dogging", "donkeyribber", "doosh", "duche", "dyke", "eat a dick", "eat hair pie", "ejaculate", "ejaculated", "ejaculates", "ejaculating", "ejaculatings", "ejaculation", "ejakulate", "erotic", "f u c k", "f u c k e r", "f_u_c_k", "f4nny", "facial", "fag", "fagging", "faggitt", "faggot", "faggs", "fagot", "fagots", "fags", "fanny", "fannyflaps", "fannyfucker", "fanyy", "fatass", "fcuk", "fcuker", "fcuking", "feck", "fecker", "felching", "fellate", "fellatio", "fingerfuck", "fingerfucked", "fingerfucker", "fingerfuckers", "fingerfucking", "fingerfucks", "fist fuck", "fistfuck", "fistfucked", "fistfucker", "fistfuckers", "fistfucking", "fistfuckings", "fistfucks", "flange", "flog the log", "fook", "fooker", "fuck hole", "fuck puppet", "fuck trophy", "fuck yo mama", "fuck", "fucka", "fuck-ass", "fuck-bitch", "fucked", "fucker", "fuckers", "fuckhead", "fuckheads", "fuckin", "fucking", "fuckings", "fuckingshitmotherfucker", "fuckme", "fuckmeat", "fucks", "fucktoy", "fuckwhit", "fuckwit", "fudge packer", "fudgepacker", "fuk", "fuker", "fukker", "fukkin", "fuks", "fukwhit", "fukwit", "fux", "fux0r", "gangbang", "gangbang", "gang-bang", "gangbanged", "gangbangs", "gassy ass", "gaylord", "gaysex", "goatse", "god", "god damn", "god-dam", "goddamn", "goddamned", "god-damned", "ham flap", "hardcoresex", "hell", "heshe", "hoar", "hoare", "hoer", "homo", "homoerotic", "hore", "horniest", "horny", "hotsex", "how to kill", "how to murdep", "jackoff", "jack-off", "jap", "jerk", "jerk-off", "jism", "jiz", "jizm", "jizz", "kawk", "kinky Jesus", "knob", "knob end", "knobead", "knobed", "knobend", "knobend", "knobhead", "knobjocky", "knobjokey", "kock", "kondum", "kondums", "kum", "kummer", "kumming", "kums", "kunilingus", "kwif", "l3i+ch", "l3itch", "labia", "LEN", "lmao", "lmfao", "lmfao", "lust", "lusting", "m0f0", "m0fo", "m45terbate", "ma5terb8", "ma5terbate", "mafugly", "masochist", "masterb8", "masterbat*", "masterbat3", "masterbate", "master-bate", "masterbation", "masterbations", "masturbate", "mof0", "mofo", "mo-fo", "mothafuck", "mothafucka", "mothafuckas", "mothafuckaz", "mothafucked", "mothafucker", "mothafuckers", "mothafuckin", "mothafucking", "mothafuckings", "mothafucks", "mother fucker", "mother fucker", "motherfuck", "motherfucked", "motherfucker", "motherfuckers", "motherfuckin", "motherfucking", "motherfuckings", "motherfuckka", "motherfucks", "muff", "muff puff", "mutha", "muthafecker", "muthafuckker", "muther", "mutherfucker", "n1gga", "n1gger", "nazi", "need the dick", "nigg3r", "nigg4h", "nigga", "niggah", "niggas", "niggaz", "nigger", "niggers", "nob", "nob jokey", "nobhead", "nobjocky", "nobjokey", "numbnuts", "nut butter", "nutsack", "omg", "orgasim", "orgasims", "orgasm", "orgasms", "p0rn", "pawn", "pecker", "penis", "penisfucker", "phonesex", "phuck", "phuk", "phuked", "phuking", "phukked", "phukking", "phuks", "phuq", "pigfucker", "pimpis", "piss", "pissed", "pisser", "pissers", "pisses", "pissflaps", "pissin", "pissing", "pissoff", "poop", "porn", "porno", "pornography", "pornos", "prick", "pricks", "pron", "pube", "pusse", "pussi", "pussies", "pussy", "pussy fart", "pussy palace", "pussys", "queaf", "queer", "rectum", "retard", "rimjaw", "rimming", "s hit", "s.o.b.", "s_h_i_t", "sadism", "sadist", "sandbar", "sausage queen", "schlong", "screwing", "scroat", "scrote", "scrotum", "semen", "sex", "sh!+", "sh!t", "sh1t", "shag", "shagger", "shaggin", "shagging", "shemale", "shi+", "shit", "shit fucker", "shitdick", "shite", "shited", "shitey", "shitfuck", "shitfull", "shithead", "shiting", "shitings", "shits", "shitted", "shitter", "shitters", "shitting", "shittings", "shitty", "skank", "slope", "slut", "slut bucket", "sluts", "smegma", "smut", "snatch", "son-of-a-bitch", "spac", "spunk", "t1tt1e5", "t1tties", "teets", "teez", "testical", "testicle", "tit", "tit wank", "titfuck", "tits", "titt", "tittie5", "tittiefucker", "titties", "tittyfuck", "tittywank", "titwank", "tosser", "turd", "tw4t", "twat", "twathead", "twatty", "twunt", "twunter", "v14gra", "v1gra", "vagina", "viagra", "vulva", "w00se", "wang", "wank", "wanker", "wanky", "whoar", "whore", "willies", "willy", "wtf", "xrated", "xxx"];

// Phrases following "do not, I repeat, do not" in various corpora. Mostly sourced from http://corpus.byu.edu
var donot_phrases = ["birth any more babies into this world", "tell me to get a hobby.", "try to contact us.", "allow that technology to fall into enemy hands", "take your best shot.", "say anything that will upset her.", "send a tweet to someone you were previously romantically linked to.", "accelerate away until the float is in a direct line with the car otherwise you will get a whiplash effect like the water skier when the boat turns.", "forget sunscreen", "come here if you aren't willing to pay $12 for a martini.", "attempt a brand new recipe on Thanksgiving day", "buy a Whirlpool refrigerator with the ice bucket and dispenser in the door.", "try to inform yourself through any other objective means of information gathering.", "UNDER ANY CIRCUMSTANCES recommend dangling large weights off the tip", "pick these things up for them yourselves", "use yellow pages", "warm the injury", "exit the vehicle unless ordered to do so.", "get it out.", "invest more than you can afford to lose.", "approach a female if you are dirty.", "speak evil of any man of God.", "get lost in the wedding day when what you should be focused on is the marriage", "snort the wine!", "buy it as your first item.", "give into the temptation of finishing up the entire platter in one sitting", "start the flight to Orbis without a gameboy.", "assume that you are free to act in a manner contrary to what your illness would necessitate until a healthcare professional is able to tell you so.", "step on a scale for several weeks.", "let your inner critic have any say in this process.", "try to attempt to communicate with these creatures if you think you have one in your vicinity", "watch the trailer for that new Denzel Washington movie, Flight.", "strike up a big friendship with this person", "get a tattoo across your shoulders asking her to marry you.", "give out security clearances", "scoop her up take her indoors and wrap a blanket around her", "make any compromise in this matter; ventilate your sleeping room completely", "read a book that you may be in the swing of up-to-date conversation", "completely acquit the Queen", "let anything happen to Paula", "seek to be aware of it", "give him your real name, your real phone number or your real address", "let the drains show from under the cape!", "in these three days give in to the body at all as regards food/sex; make yourself holy unto God", "let go of the robe of Jesus", "lock up your legs just before hitting the ground!", "date until you are at least 16 years old.", "use sex as a means to persuade your man into a committed relationship", " even consider giving up on him", "(I assured them) mention me, please, to anyone until I give them the information they desperately seek.", "accept them", "go in there!", "distribute to physicians any year-end bonuses based on the HMO's economic performance", "touch the bird", "let the Saudis see your Christmas trees", "disgrace me this time", "enter an area of high radiation!", "chase the bear through the woods", "tell her that your claim to danger is that one time you attended a Tae Bo class ", "and had to leave because you pulled a muscle.", "get the wrong end of a rabbit that doesn't want to be eaten", "default into doing what everyone at your fertility clinic recommends (like I did)", "burn any bridges when seeking financing", "launch a missile attack", "ever let him convince you otherwise", "STUFF THE TURKEY", "hit him over the head with it", "Sunny Alvarez, hide behind a veil of tears and let me down", "add things to the cart which are not on the list.", "attack unless they attack you first", "keep Walking", "buy the day a company IPOs", "saddle-up the hound", "eat the raw dough!", "get your sex tips from pornos!!!", "let her involve you in a game of bridge.", "make a fool of yourself by letting that ugly head of jealousy poke into your potentially amazing relationship", "create your key features in Flash", "endeavour to conceal my rosin in your breeches pocket.", "check your e-mail messages as soon as they arrive in your inbox. ", "butt in and cut her off by giving advice on how she should have handled the situation.", "make customers work to give you their money.", "say 'whatever', 'I don't care', 'It doesn't matter' or anything along these lines.", "approach the individual or individuals, but immediately call the police.", "get a pay day loan these are dangerous loans that will put you in serious financial trouble they are set up by greedy people", "try to solve anything yourself.", "keep me waiting", "mix things up and pee inside your mouthwash container.", "have sex that does not deeply satisfy you.", "cut up encyclopedias or other published books.", "hurry.", "let them bait you into making foolish mistakes.", "wash your cast iron skillet with dish soap", "go to Hawai'i on vaca'ation", "dispose of nail polish or remover down the drain", "BURN IT!", "buy all the bread on the shelves", "believe any rumors that there will be a new Apple TV", "get your hopes up", "give strangers lifts!!!!!", "watch Zumanity with your parents or anyone you'd be uncomfortable watching porn", "walk up to him, and celebrate his wicket by clapping and cheering", "allow that technology to fall into enemy hands"];


var request = require("request");
var cheerio = require("cheerio");
var nlp = require('nlp_compromise');


	/* Function: randomNumber
	Returns a random integer from 1 to max. Return 1 if max <= 1 or not a number.

	Parameters:
	max - an integer, the highest number that might be returned.

	Returns:
	number (integer) between 1 and max.
	*/
	var randomNumber = function (max, min) {
		if (min === undefined) {
			if (max <= 1 || typeof max !== "number") {
				return 1;
			}
			return Math.floor(Math.random() * Math.round(max)) + 1;
		}
		else {
			if (max <= 1 || typeof max !== "number" || max <= min || typeof min !== "number") {
				return 1;
			}
		    return Math.floor(Math.random() * (max - min + 1)) + min;
		}
	}

	var _noRepeatTracker = {}

	/* Function: randomNoRepeat
	Like <randomNumber>, but returns a number that tries to be different from the last random number requested for this same key.

	Parameters:
	key - a string representing a unique key. For the same key, calls to randomNoRepeat will try to return a different number than the last call.
	max - an integer, the highest number that might be returned.

	Returns:
	number (integer) between 1 and max.
	*/
	var randomNoRepeat = function (key, max) {
		var num = 0,
			lastTime = _noRepeatTracker[key];

		if (typeof max !== "number") {
			throw new Error("util.randomNoRepeat(): called with max of " + max + " which is " + typeof max + " instead of number.");
		}
		if (max <= 1) {
			return 1;
		}

		if (lastTime === undefined) {
			num = randomNumber(max);
		} else {
			num = randomNumber(max - 1);
			if (num >= lastTime) {
				num += 1;
			}
		}
		_noRepeatTracker[key] = num;
		return num;
	}

	var oneOfNoRepeat = function (key, arr) {
		if (!isArray(arr) || arr.length === 0) {
			return undefined;
		}
		if (arr.length === 1) {
			return arr[0];
		}
		return arr[randomNoRepeat(key, arr.length) - 1];
	}

	var isArray = function(obj) {
		return toString.call(obj) === "[object Array]";
	}

	var iCap = function (str) {
		if (typeof str !== "string") {
			throw new Error("util.iCap(): called iCap on " + str + " which is not a string.");
		}
		return str.charAt(0).toUpperCase() + str.slice(1);
	}

	var escapeRegExp = function(str) {
	  return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
	}



var resultHTML = [];
var numUrls = -1;
var timesWaited = 0;
var orig_phrase = "";

var start = function(phrase) {
	resultHTML = [];
	timesWaited = 0;
	console.log("\n\n\n * * * * * * * * * * * * * * * * * * * * * *");
	console.log("Generating story for phrase \"" + phrase + "\"");
	console.log(" * * * * * * * * * * * * * * * * * * * * * *");
	orig_phrase = phrase;
	var searchTerm = getSearchTerm(phrase);
	var url = "https://www.google.com/search?q=" + searchTerm + "";
	console.log("getting " + url);
	request(url, function (error, response, body) {
		if (!error) {
			var urls = processGoogleResult(body);
			numUrls = urls.length;
			console.log("Getting " + numUrls + " result urls...");
			grabAndProcessUrls(urls);
			setTimeout(hopefullyFinished, pingInterval);
		} else {
			console.log("We’ve encountered an error: " + error);
		}
	});
}

var getSearchTerm = function(phrase) {
	// Use exact phrase if 4 or less, otherwise search for whole thing.
	phrase = phrase.replace(/\W/g, " ").replace(/\s{2,}/g, " ").trim();
	if (phrase.split(" ").length <= 4) {
		return '"' + phrase.split(" ").join("+") + '"';
	}
	return phrase.split(" ").join("+");
}

var processGoogleResult = function(body) {
	var $ = cheerio.load(body);
	var linkEls = $("h3 a");
	var urls = [];
	for (var key in linkEls) {
		if (linkEls[key].attribs && linkEls[key].attribs.href) {
			var url = linkEls[key].attribs.href;
			url = url.substring(7, url.length);
			url = url.substring(0, url.indexOf("&sa="));
			if (url.indexOf(".pdf") >= 0) continue;
			urls.push(url);
		}
	}
	return urls;
}

var grabAndProcessUrls = function(urls) {
	urls.forEach(function(url) {
		console.log("Getting " + url);
		request(url, function (error, response, body) {
			if (!error) {
				resultHTML.push(body);
			} else {
				console.log("Error on link " + url);
			}
		});
	})
}

var hopefullyFinished = function() {
	if (resultHTML.length >= numUrls) {
		console.log("Finished!");
		processPages();
	} else if (timesWaited >= maxTimesToWait) {
		console.log("Giving up waiting; processing with " + resultHTML.length + "values.");
		processPages();
	}
	else {
		console.log("Waiting for " + (numUrls - resultHTML.length) + " more...");
		timesWaited += 1;
		setTimeout(hopefullyFinished, pingInterval);
	}
}

var processPages = function() {
	var sentences = [];
	for (var i = 0; i < resultHTML.length; i++) {
		console.log("Processing link " + i);
		sentences = sentences.concat(getSentencesFromResultsPage(resultHTML[i]));
	}
	var output = makeStory(sentences);
	// console.log(htmlToConsole(output));
	console.log("Chapter " + story_ctr + " complete!");
	console.log("\"Do not, I repeat, do not " + orig_phrase + "\"\n\n");
	console.log("Coming up next: \"Do not, I repeat, do not " + donot_phrases[story_ctr + 1] + "\"\n");
	saveAndDisplayHtml(header + output + footer);
	saveHtmlForBook(output);
	wait();
}

var getSentencesFromResultsPage = function(body) {
	var $ = cheerio.load(body);
	var paragraphs = $("p").text();
	paragraphs = paragraphs.replace(/([a-z])([A-Z])/g, "$1. $2");
	paragraphs = paragraphs.replace(/\n/g, ".");
	paragraphs = paragraphs.replace(/\!/g, "!   ");
	paragraphs = paragraphs.replace(/\./g, ".   ");
	paragraphs = paragraphs.replace(/\?/g, "?   ");
	paragraphs = paragraphs.replace(/’/g, "'");
	var raw_sentences = paragraphs.split("   ");
	var sentences = [];
	for (var i = 0; i < raw_sentences.length; i++) {
		var sent = raw_sentences[i].trim()
		if (sent.indexOf("|") >= 0) continue;
		if (sent.match(/^\W/)) continue;
		if (sent.match(/\t/)) continue;
		if (sent.match(/http/)) continue;
		if (sent.match(/[{}\[\]@]/)) continue;
		var offensive_found = false;
		for (var j = 0; j < offensiveWords.length; j++) {
			if (sent.indexOf(offensiveWords[j]) >= 0) {
				offensive_found = true;
				break;
			}
		}
		if (offensive_found) continue;
		sent = sent.replace(/ ([,.!?;:])/g, "$1");
		sent = iCap(sent);
		if (sent.length >= 3) {	
			sentences.push(sent);
		}
	}
	console.log("--> added " + sentences.length + " sentences.");
	// console.log(sentences.map(function(s){return s + " --> " + iCap(pastify(s));}));
	return sentences;
}










var storifySentence = function(s) {
	s = iCap(pastify(s));
	var people = nlp.text(s).people();
	if (people.length > 0) {
		var expression = "\\b" + escapeRegExp(people[0].text) + "\\b";
	    var rx = new RegExp(expression, 'ig');
		s = s.replace(rx, hero);
	}
	return s;
}



// Return only the entries in list which contain something from filterWords.
var filterByList = function(list, filterWords) {
	var filterList = [];
	var unfilterList = [];
	var filteredByFreq = {};
	var max = 0;
	list.forEach(function(item) {
	    var cnt = 0;
		for (var i = 0; i < filterWords.length; i++) {

			var expression = "\\b" + filterWords[i] + "\\b";
		    var rx = new RegExp(expression, 'i');

			if (item.match(rx) !== null) {
			// if (item.indexOf(filterWords[i]) >= 0) {
				cnt += 1;
			} 
		}

		if (cnt > 0) {
			if (!filteredByFreq[cnt]) {
				filteredByFreq[cnt] = [];
			}
			filteredByFreq[cnt].push(item);
			if (cnt > max) {
				max = cnt;
			}
		} else {
			if (unfilterList.indexOf(item) < 0)
				unfilterList.push(item);
		}
	});
	for (var i = max; i > 0; i--) {
		if (filteredByFreq[i]) {
			// console.log(i + ": " + filteredByFreq[i]);
			filterList = filterList.concat(filteredByFreq[i])
		}
	}
	console.log("Found " + filterList.length + " bad sentences and " + unfilterList.length + " normal sentences.");
	var results = {
		filtered: filterList,
		unfiltered: unfilterList
	}
	return results;
}

var pastify = function(phrase) {
	// var p = nlp.sentence(phrase).to_past().text();
	var p = phrase;
	p = p.replace(/\byou're\b/gi, heroThey + " is");
	p = p.replace(/\byou'll\b/gi, heroThey + "'ll");
	p = p.replace(/\byourself\b/gi, heroThem + "self");
	p = p.replace(/\byour\b/gi, hero + "'s");
	p = p.replace(/\byou\b/gi, heroThey);
	p = p.replace(/\bI'd\b/gi, heroThey + "'d");
	p = p.replace(/\bI'm\b/gi, heroThey + "'s");
	p = p.replace(/\bI'll\b/gi, heroThey + "'ll");
	p = p.replace(/\bI\b/gi, heroThey);
	// p = p.replace(/\bdon'ted\b/gi, "didn't");
	// p = p.replace(/\bdoesn'ted had\b/gi, "didn't have");
	// p = p.replace(/\bdoesn'ted\b/gi, "didn't");
	// p = p.replace(/\bit's was\b/gi, "it was");
	// p = p.replace(/\bBob been\b/gi, hero + " was");
	// p = p.replace(/\bplaned\b/gi, "planned");
	// p = p.replace(/\bmighted been\b/gi, "might have been");
	return p;
}

var actual_pastify = function(phrase) {
	phrase = phrase.toLowerCase();
	var p = nlp.sentence(phrase).to_past().text();
	p = p.replace(/\byou're was\b/gi, heroThey + " was");
	p = p.replace(/\byou'll was\b/gi, heroThey + " had");
	p = p.replace(/\byourself\b/gi, heroThem + "self");
	p = p.replace(/\byour\b/gi, heroTheir);
	p = p.replace(/\byou\b/gi, heroThey);
	p = p.replace(/\bdon'ted\b/gi, "didn't");
	p = p.replace(/\bdoesn'ted had\b/gi, "didn't have");
	p = p.replace(/\bdoesn'ted\b/gi, "didn't");
	p = p.replace(/\bit's was\b/gi, "it was");
	p = p.replace(/\bBob been\b/gi, hero + " was");
	p = p.replace(/\bplaned\b/gi, "planned");
	p = p.replace(/\bmighted been\b/gi, "might have been");
	return p;
}

var header = '<html><head><link href="https://fonts.googleapis.com/css?family=Gentium+Basic|Slabo+27px|Yrsa" rel="stylesheet"><link rel="stylesheet" type="text/css" href="../style.css"></head><body>';
var footer = "</body></html>";
// var chapter = 1;

var makeStory = function(sentences) {
	var results = filterByList(sentences, badWords);
	var badSentences = results.filtered;
	sentences = results.unfiltered;
	// sentences.forEach(function(s){console.log(s)});
	// badSentences.forEach(function(s){console.log(s)});
	var output = "";
	output += "<h1>Chapter " + story_ctr + "</h1> <h2>\"Do not, I repeat, do not " + orig_phrase + "\"</h2>";
	// chapter += 1;
	output += "<p>" + hero + " " + actual_pastify(orig_phrase) + ".</p>";
	output += "<p>At first things seemed all right. ";
	var numSentences = randomNumber(firstPartSentencesMax - firstPartSentencesMin) + firstPartSentencesMin;
	console.log("\nWriting first paragraph of " + numSentences + " normal sentences...");
	var backups = [];
	var actual = 0;
	var totalVarietySentences = 0;
	var timesPrintedRejectMsg = 0;
	for (var i = 0; actual < numSentences && i < 100; i++) {
		var possible = storifySentence(oneOfNoRepeat("sentences", sentences)) + " ";
		if (possible.indexOf(hero) === -1) {
			if (randomNumber(100) > 25 || totalVarietySentences >= 2) {
				if (timesPrintedRejectMsg < 6) {
					console.log("Reject b/c no ref to hero: '" + possible + "'");
					timesPrintedRejectMsg +=1;
				}
				backups.push(possible);
				continue;
			} else {
				totalVarietySentences += 1;
				console.log("For variety, keeping sentence with no ref to hero: '" + possible + "'");
			}
		}
		actual += 1;
		output += possible;
	}
	if (actual < numSentences) {
		for (i = 0; i < backups.length; i++) {
			output += backups[i];
			actual += 1;
			if (actual >= numSentences) break;
		}
	}
	output += "</p><p>Then, things went from bad to worse. ";
	numSentences = randomNumber(secondPartSentencesMax - secondPartSentencesMin) + secondPartSentencesMin;
	console.log("Sorting negative sentences by most match words first...");
	var lengthSortedBads = [].concat(badSentences).sort(function(a, b){
	  return a.length - b.length;
	});
	if (lengthSortedBads.length > 6) {
		lengthSortedBads = lengthSortedBads.slice(0, Math.floor(lengthSortedBads.length / 2));
	}
	if (badSentences.length > numSentences * 2) {
		badSentences = badSentences.slice(0, Math.floor(badSentences.length / 2));
	}
	console.log("\nWriting second paragraph of " + numSentences + " negative sentences.");
	for (i = 0; i < numSentences; i++) {
		var sent;
		if (i % 2 === 0) {
			sent = lengthSortedBads.shift();
		} else {
			sent = oneOfNoRepeat("badSentences", badSentences);
		}
		sent = sent.substr(0, sent.length-1) + "!";
		output += storifySentence(sent) + " ";
	}
	console.log("Writing conclusion.");
	output += "</p><p>All in all, " + hero + " wished " + heroThey + " had listened to the advice. " + iCap(heroThey) + " " + actual_pastify(orig_phrase) + ". " + iCap(heroThey) + " wished " + heroThey + " hadn't.</p>";
	return output;
}

var htmlToConsole = function(story) {
	story = story.replace("<hr>", "\n\n\n\n\n\n\n\n\n\n\n\n\n**************************\n");
	story = story.replace("<h1>", "");
	story = story.replace("</h1>", ":");
	story = story.replace("<h2>", "");
	story = story.replace("</h2>", "\n\n");
	story = story.replace("<p>", "");
	story = story.replace("</p>", "\n\n");
	story = story.replace(header, "");
	story = story.replace(footer, "");
	return story;
}

var fs = require("fs");
var saveAndDisplayHtml = function(story) {
	var id = new Date().getTime();
	var fn = "stories/" + id + ".html";
	fs.writeFile(fn, story, function(err) {
	    if(err) {
	        return console.log(err);
	    }

	    // console.log("The file was saved!");
	    // var spawn = require('child_process').spawn
		// spawn('open', [fn]);
	}); 
}

var saveHtmlForBook = function(story) {
	story = story + "\n\n<hr>\n\n";
	var id = new Date().getTime();
	var fn = "book_stories/" + id + ".html";
	fs.writeFile(fn, story, function(err) {
	    if(err) {
	        return console.log(err);
	    }
	}); 
}



var story_ctr;
var kickoff = function() {
	story_ctr = startChapter;
	var phrase = donot_phrases[story_ctr-1];
	start(phrase);
}

var sec_ctr = 20;

var process = require("process");
var wait = function() {
	sec_ctr = beats_between_stories;
	console.log(" ");
	process.stdout.write("Next story in " + sec_ctr + " ");
	setTimeout(countdown, seconds_between_stories * 1000 / 20);
}
var countdown = function() {
	sec_ctr -= 1;
	if (sec_ctr > 0) {
		process.stdout.write(sec_ctr + " ");
		setTimeout(countdown, seconds_between_stories * 1000 / 20);
	} else {
		if (story_ctr < donot_phrases.length) {
			story_ctr += 1;
			start(donot_phrases[story_ctr]);
		} else {
			console.log("Finished!");
		}
	}
}


var hero = "Sheldon";

// var heroThey = "she";
// var heroThem = "her";
// var heroTheir = "her";

// var heroThey = "they";
// var heroThem = "them";
// var heroTheir = "their";

var heroThey = "he";
var heroThem = "him";
var heroTheir = "his";

var startChapter = 72;
var pingInterval = 1000;
var firstPartSentencesMin = 5;
var firstPartSentencesMax = 7;
var secondPartSentencesMin = 4;
var secondPartSentencesMax = 6;
var maxTimesToWait = 10;
var seconds_between_stories = 20;
var beats_between_stories = 20;

// start("watch the trailer for that new Denzel Washington movie, Flight");

kickoff();








